/*
 * 机具回收明细
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class RecycMachineOrderPosController : BaseController
    {
        public RecycMachineOrderPosController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 机具回收明细列表

        /// <summary>
        /// 根据条件查询机具回收明细列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(RecycMachineOrderPos data, string right, string OrderId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.OrderId = OrderId;


            return View();
        }

        #endregion

        #region 根据条件查询机具回收明细列表

        /// <summary>
        /// 机具回收明细列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(RecycMachineOrderPos data, string OrderNo, string CreateDateData, string BrandIdSelect, string StatusSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("SnNo", "1"); //机具SN


            string condition = " and Status>=-1";
            if (!string.IsNullOrEmpty(CreateDateData))
            {
                string[] datelist = CreateDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and CreateDate>='" + start + " 00:00:00' and CreateDate<='" + end + " 23:59:59'";
            }
            //申请订单
            if (!string.IsNullOrEmpty(OrderNo))
            {
                var recycMachineOrder = db.RecycMachineOrder.FirstOrDefault(m => m.RecycOrderNo == OrderNo) ?? new RecycMachineOrder();
                condition += " and OrderId=" + recycMachineOrder.Id;
            }
            //机具品牌
            if (!string.IsNullOrEmpty(BrandIdSelect))
            {
                condition += " and BrandId=" + BrandIdSelect;
            }
            //状态
            if (!string.IsNullOrEmpty(StatusSelect))
            {
                condition += " and Status=" + StatusSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("RecycMachineOrderPos", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //机具品牌
                dic["BrandId"] = RelationClass.GetKqProductsInfo(int.Parse(dic["BrandId"].ToString()));

                //状态
                int Status = int.Parse(dic["Status"].ToString());//Status(-1 撤回 0 待处理 1 已确认 2 驳回)
                if (Status == -1) dic["Status"] = "撤回";
                if (Status == 0) dic["Status"] = "待处理";
                if (Status == 1) dic["Status"] = "已确认";
                if (Status == 2) dic["Status"] = "驳回";

                int OrderId = int.Parse(dic["OrderId"].ToString());
                var recycMachineOrder = db.RecycMachineOrder.FirstOrDefault(m => m.Id == OrderId) ?? new RecycMachineOrder();
                dic["OrderNo"] = recycMachineOrder.RecycOrderNo;
            }
            return Json(obj);
        }

        #endregion

        #region 增加机具回收明细

        /// <summary>
        /// 增加或修改机具回收明细信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right, string OrderId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.OrderId = OrderId;


            return View();
        }

        #endregion

        #region 增加机具回收明细

        /// <summary>
        /// 增加或修改机具回收明细信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(RecycMachineOrderPos data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("OrderId", data.OrderId);


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("RecycMachineOrderPos", Fields, 0);
            AddSysLog(data.Id.ToString(), "RecycMachineOrderPos", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改机具回收明细

        /// <summary>
        /// 增加或修改机具回收明细信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, string OrderId, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.OrderId = OrderId;


            RecycMachineOrderPos editData = db.RecycMachineOrderPos.FirstOrDefault(m => m.Id == Id) ?? new RecycMachineOrderPos();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改机具回收明细

        /// <summary>
        /// 增加或修改机具回收明细信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(RecycMachineOrderPos data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("OrderId", data.OrderId);


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("RecycMachineOrderPos", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "RecycMachineOrderPos", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除机具回收明细信息

        /// <summary>
        /// 删除机具回收明细信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "RecycMachineOrderPos", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("RecycMachineOrderPos", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "RecycMachineOrderPos", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("RecycMachineOrderPos", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "RecycMachineOrderPos", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("RecycMachineOrderPos", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("RecycMachineOrderPos", Sort, Id);

            AddSysLog(Id.ToString(), "RecycMachineOrderPos", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.RecycMachineOrderPos.Add(new RecycMachineOrderPos()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "RecycMachineOrderPos", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(RecycMachineOrderPos data, string OrderIdSelect, string BrandIdSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("SnNo", "1"); //机具SN


            string condition = " and Status>-1";
            //申请订单Id
            if (!string.IsNullOrEmpty(OrderIdSelect))
            {
                condition += " and OrderId=" + OrderIdSelect;
            }
            //机具品牌
            if (!string.IsNullOrEmpty(BrandIdSelect))
            {
                condition += " and BrandId=" + BrandIdSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("RecycMachineOrderPos", Fields, "Id desc", "0", 1, 20000, condition, "ResultDate,CancelDate", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //机具品牌
                dic["BrandId"] = RelationClass.GetKqProductsInfo(int.Parse(dic["BrandId"].ToString()));

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("ResultDate", "确认或驳回时间");
            ReturnFields.Add("CancelDate", "创客撤销时间");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "RecycMachineOrderPos", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
